summary refs log tree commit diff
path: root/util/docker_build.sh
diff options
context:
space:
mode:
authorKonstantin Đorđević <vomindoraan@gmail.com>2018-12-08 18:42:46 +0100
committerMechMerlin <30334081+mechmerlin@users.noreply.github.com>2018-12-08 09:42:46 -0800
commit13ad6501361faa9433562dba4ea8c55f85bf1dc5 (patch)
treec6ac7ff8074cd4bb1f920fa0a204219d76fb8d0a /util/docker_build.sh
parent2ad2b73d685cf25268fa7d3726f45594edee70c4 (diff)
Add a better Docker build script + update Dockerfile (#4222)
* Add a Docker build script

* Add usage and error messages

* Add -r to reads

Thanks mechmerlin

* Add keyboard:keymap form, improve script

* Add target argument, change usage forms in script

* Add check for more than 3 args in keyboard:keymap:target form

* Change Docker base image to debian, use community repo

This matches what qmk_compiler uses (https://github.com/qmk/qmk_compiler/blob/master/Dockerfile#L1).

I've removed the maintainer as we now have a community build on Docker Hub (https://hub.docker.com/r/qmkfm/qmk_firmware). This Dockerfile will also be maintained by the community.

* Change build command format to keyboard:keymap

* Call make directly in container run command

* Simplify script, remove 3-arg form

* Add COPY to Dockerfile so images are usable in and of themselves

Also change WORKDIR from /qmk to /qmk_firmware

* Add USB pass-through for Linux and docker-machine hosts

* Read directly into variables instead of array

* Alphabetically sort dependencies in Dockerfile

* Set executable bit on util/docker_build.sh

* Update Docker docs

* Add warning about Docker on Windows

* Expand comment in docs

* Check docker-machine exit code instead of string

* Only match --help with whole arguments

* Make script POSIX-compliant

* Convert script indentation to tabs
Diffstat (limited to 'util/docker_build.sh')
-rwxr-xr-xutil/docker_build.sh49
1 files changed, 49 insertions, 0 deletions
diff --git a/util/docker_build.sh b/util/docker_build.sh
new file mode 100755
index 0000000000..26075cc908
--- /dev/null
+++ b/util/docker_build.sh
@@ -0,0 +1,49 @@
+#!/bin/sh
+# NOTE: This script uses tabs for indentation
+
+USAGE="Usage: $0 [keyboard[:keymap[:target]]]"
+
+# Check preconditions
+for arg; do
+	if [ "$arg" = "--help" ]; then
+		echo "$USAGE"
+		exit 0
+	fi
+done
+if [ $# -gt 1 ]; then
+	echo "$USAGE" >&2
+	exit 1
+elif ! command -v docker >/dev/null 2>&1; then
+	echo "Error: docker not found" >&2
+	echo "See https://docs.docker.com/install/#supported-platforms for installation instructions" >&2
+	exit 2
+fi
+
+# Determine arguments
+if [ $# -eq 0 ]; then
+	printf "keyboard=" && read -r keyboard
+	[ -n "$keyboard" ] && printf "keymap=" && read -r keymap
+	[ -n "$keymap"   ] && printf "target=" && read -r target
+else
+	IFS=':' read -r keyboard keymap target x <<-EOF
+	$1
+	EOF
+	if [ -n "$x" ]; then
+		echo "$USAGE" >&2
+		exit 1
+	fi
+fi
+if [ -n "$target" ]; then
+	if [ "$(uname)" = "Linux" ] || docker-machine active >/dev/null 2>&1; then
+		usb_args="--privileged -v /dev/bus/usb:/dev/bus/usb"
+	else
+		echo "Error: target requires docker-machine to work on your platform" >&2
+		echo "See http://gw.tnode.com/docker/docker-machine-with-usb-support-on-windows-macos" >&2
+		exit 3
+	fi
+fi
+dir=$(pwd -W 2>/dev/null) || dir=$PWD  # Use Windows path if on Windows
+
+# Run container and build firmware
+docker run --rm $usb_args -v "$dir":/qmk_firmware qmkfm/qmk_firmware \
+	make "$keyboard${keymap:+:$keymap}${target:+:$target}"